library ieee;
use ieee.std_logic_1164.all;

library work;
use mypack.all;

/*
	Demonstration fr einen Automaten.
	Zugleich Demonstration fr Aufzhlungstyp und user defined attribute
*/

entity ampel is
	port
	(
		clk: 		in 	std_logic;
		control:	in 	ampel_kontrolle;
		led_rot, led_gruen, led_gelb: out std_logic
	);
	-- Zuweisung des Attributs "pin" mit dem Wert H16 an das Signal clk
	attribute pin of clk: signal is "H16";
	
end;


architecture mfm of ampel is
	signal ampel_record: ampel_alles;
	signal ausgabe: std_logic_vector(1 to 3);
 
begin
		
	-- Ausgabe an die Ports 
	with ampel_record.zustand select
	ausgabe <= 	"100" when rot,
					"101" when rotgelb,
					"010" when gruen,
					"001" when gelb,
					"000" when others;
	
	-- Bestimmung der Ausgabe an die LED
	(led_rot, led_gruen, led_gelb) <= ausgabe;

					
	-- Bestimmung des Folgezustands (Automat)
	ablauf:
	process (clk) is
		
	begin
		if (rising_edge(clk))
		then
		-- hier der synchrone teil, hier DFF
		
		-- bestimme die betriebstart
		case control is
			when haupt =>
				case ampel_record.zustand is
					when rot => ampel_record.zustand <= rotgelb;
					when rotgelb => ampel_record.zustand <= gruen;
					when gruen => ampel_record.zustand <= gelb;
					when gelb => ampel_record.zustand <= rot;
					when others => ampel_record.zustand <= rot;
				end case;
				
			when neben =>
				case ampel_record.zustand is
					when gelb => ampel_record.zustand <= aus;
					when others => ampel_record.zustand <= gelb;
				end case;
				
			when others => 
					ampel_record.zustand <= aus;
			
					
		end case;
		
		end if;
	end process;

end;