library ieee;
use ieee.std_logic_1164.all;

library work;
use mypack.all;

/*
	Multiplexer, bei dem 
	
	- die Anzahl der Eingnge
	- die Breite der Eingnge
	
	ber generics festgelegt werden knnen
*/
	

entity genmux is
	generic
	(
		N:	positive := 2;		-- number of input signals
		L: positive := 1		-- vector width
	);
	port
	(
		SEL: 	in 	positive range 1 to N;
		Y: 	out 	std_logic_vector(0 to L-1);
		X: 	in 	vector_array_t(1 to N)(0 to L-1)
	);
end;


architecture mfm of genmux is

begin
	
	y <= x(SEL);
end;