library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


-- Deklarationen (Konstanten, Komponenten, Typen, Funktionen, Prozeduren)
package mypack is
 	type 	ampel_zustand is (aus, rot, rotgelb, gruen, gelb);
	type	ampel_kontrolle is (aus, neben, haupt);
	
	attribute pin: string;
	
	-- Feldprototyp mit 2 Freiheitsgraden
	-- 1. Lnge der Elemente (Vektor)
	-- 2. Anzahl der Elemente 
	type vector_array_t is array(natural range <>) of std_logic_vector;
	
	type ampel_alles is
	record
		zustand: ampel_zustand;
		control:	ampel_kontrolle;
	end record; 

end package;
 

-- Definitionen (Funktionen und Prozeduren)
package body mypack is

end; 
